/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001-02 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.ui;

import java.io.IOException;
import java.io.Writer;
import javax.servlet.ServletException;
import com.silverwrist.venice.util.ServiceProvider;

public interface RequestOutput extends ServiceProvider, LinkTypes
{
  public abstract Writer getWriter() throws IOException;

  public abstract void write(String s) throws IOException;

  public abstract void writeStackTrace(Throwable t) throws IOException;

  public abstract void flush() throws IOException;

  public abstract void output(Content c) throws IOException, ServletException;

  public abstract void output(Writer out, Content c) throws IOException, ServletException;

  public abstract void writeFrameHead(Writer out, Content c) throws IOException;

  public abstract void writeFrameHead(Content c) throws IOException;

  public abstract void writeSiteImageTag(Writer out) throws IOException;

  public abstract void writeSiteImageTag() throws IOException;

  public abstract void writeVeniceLogo(Writer out) throws IOException;

  public abstract void writeVeniceLogo() throws IOException;

  public abstract void writeContentHeader(Writer out, String primary, String secondary) throws IOException;

  public abstract void writeContentHeader(String primary, String secondary) throws IOException;

} // end interface RequestOutput
